<template>
  <bh-bizcard-details-ui
    v-if="bizcard"
    :bizcard="bizcard"
    @go-home="$emit('go-home')"
  />
</template>

<script>
export default {
  name: 'BhBizcardDetails',
  props: {
    slug: {
      type: String,
      default: null,
    },
  },
  // fetchOnServer: process.env.NODE_ENV !== 'development',
  data: () => ({
    bizcard: null,
  }),
  async fetch() {
    try {
      this.bizcard = await this.$dataService.getBizcard({ slug: this.slug });
      this.$store.dispatch('bizcards/setSelectedBizcard', this.bizcard.slug);
    } catch (error) {
      const next = {
        404: { path: '/unavailable', query: null },
        500: { path: '/server-error', query: { mid: 'bizcard.fetch.error' } },
      };
      // prettier-ignore
      const { path, query } = error.message === 'Unavailable' ? next[404] : next[500];

      if (process.server) {
        this.$nuxt.context.redirect(path, query);
      }
      if (process.client) {
        this.$router.push({ path, query });
      }
    }
  },
};
</script>
